<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPurchaseMobilePOSRequest ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPurchaseMobilePOSRequest
 * @subpackage Arrays
 */
class ArrayOfPurchaseMobilePOSRequest extends AbstractStructArrayBase
{
    /**
     * The PurchaseMobilePOSRequest
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PurchaseMobilePOSRequest[]
     */
    public $PurchaseMobilePOSRequest;
    /**
     * Constructor method for ArrayOfPurchaseMobilePOSRequest
     * @uses ArrayOfPurchaseMobilePOSRequest::setPurchaseMobilePOSRequest()
     * @param \StructType\PurchaseMobilePOSRequest[] $purchaseMobilePOSRequest
     */
    public function __construct(array $purchaseMobilePOSRequest = array())
    {
        $this
            ->setPurchaseMobilePOSRequest($purchaseMobilePOSRequest);
    }
    /**
     * Get PurchaseMobilePOSRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PurchaseMobilePOSRequest[]|null
     */
    public function getPurchaseMobilePOSRequest()
    {
        return isset($this->PurchaseMobilePOSRequest) ? $this->PurchaseMobilePOSRequest : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPurchaseMobilePOSRequest method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPurchaseMobilePOSRequest method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePurchaseMobilePOSRequestForArrayConstraintsFromSetPurchaseMobilePOSRequest(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPurchaseMobilePOSRequestPurchaseMobilePOSRequestItem) {
            // validation for constraint: itemType
            if (!$arrayOfPurchaseMobilePOSRequestPurchaseMobilePOSRequestItem instanceof \StructType\PurchaseMobilePOSRequest) {
                $invalidValues[] = is_object($arrayOfPurchaseMobilePOSRequestPurchaseMobilePOSRequestItem) ? get_class($arrayOfPurchaseMobilePOSRequestPurchaseMobilePOSRequestItem) : sprintf('%s(%s)', gettype($arrayOfPurchaseMobilePOSRequestPurchaseMobilePOSRequestItem), var_export($arrayOfPurchaseMobilePOSRequestPurchaseMobilePOSRequestItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PurchaseMobilePOSRequest property can only contain items of type \StructType\PurchaseMobilePOSRequest, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PurchaseMobilePOSRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PurchaseMobilePOSRequest[] $purchaseMobilePOSRequest
     * @return \ArrayType\ArrayOfPurchaseMobilePOSRequest
     */
    public function setPurchaseMobilePOSRequest(array $purchaseMobilePOSRequest = array())
    {
        // validation for constraint: array
        if ('' !== ($purchaseMobilePOSRequestArrayErrorMessage = self::validatePurchaseMobilePOSRequestForArrayConstraintsFromSetPurchaseMobilePOSRequest($purchaseMobilePOSRequest))) {
            throw new \InvalidArgumentException($purchaseMobilePOSRequestArrayErrorMessage, __LINE__);
        }
        if (is_null($purchaseMobilePOSRequest) || (is_array($purchaseMobilePOSRequest) && empty($purchaseMobilePOSRequest))) {
            unset($this->PurchaseMobilePOSRequest);
        } else {
            $this->PurchaseMobilePOSRequest = $purchaseMobilePOSRequest;
        }
        return $this;
    }
    /**
     * Add item to PurchaseMobilePOSRequest value
     * @throws \InvalidArgumentException
     * @param \StructType\PurchaseMobilePOSRequest $item
     * @return \ArrayType\ArrayOfPurchaseMobilePOSRequest
     */
    public function addToPurchaseMobilePOSRequest(\StructType\PurchaseMobilePOSRequest $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PurchaseMobilePOSRequest) {
            throw new \InvalidArgumentException(sprintf('The PurchaseMobilePOSRequest property can only contain items of type \StructType\PurchaseMobilePOSRequest, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PurchaseMobilePOSRequest[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PurchaseMobilePOSRequest|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PurchaseMobilePOSRequest|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PurchaseMobilePOSRequest|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PurchaseMobilePOSRequest|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PurchaseMobilePOSRequest|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PurchaseMobilePOSRequest
     */
    public function getAttributeName()
    {
        return 'PurchaseMobilePOSRequest';
    }
}
