<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTransactionResult ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTransactionResult
 * @subpackage Arrays
 */
class ArrayOfTransactionResult extends AbstractStructArrayBase
{
    /**
     * The TransactionResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TransactionResult[]
     */
    public $TransactionResult;
    /**
     * Constructor method for ArrayOfTransactionResult
     * @uses ArrayOfTransactionResult::setTransactionResult()
     * @param \StructType\TransactionResult[] $transactionResult
     */
    public function __construct(array $transactionResult = array())
    {
        $this
            ->setTransactionResult($transactionResult);
    }
    /**
     * Get TransactionResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TransactionResult[]|null
     */
    public function getTransactionResult()
    {
        return isset($this->TransactionResult) ? $this->TransactionResult : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTransactionResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTransactionResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTransactionResultForArrayConstraintsFromSetTransactionResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTransactionResultTransactionResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfTransactionResultTransactionResultItem instanceof \StructType\TransactionResult) {
                $invalidValues[] = is_object($arrayOfTransactionResultTransactionResultItem) ? get_class($arrayOfTransactionResultTransactionResultItem) : sprintf('%s(%s)', gettype($arrayOfTransactionResultTransactionResultItem), var_export($arrayOfTransactionResultTransactionResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TransactionResult property can only contain items of type \StructType\TransactionResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TransactionResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TransactionResult[] $transactionResult
     * @return \ArrayType\ArrayOfTransactionResult
     */
    public function setTransactionResult(array $transactionResult = array())
    {
        // validation for constraint: array
        if ('' !== ($transactionResultArrayErrorMessage = self::validateTransactionResultForArrayConstraintsFromSetTransactionResult($transactionResult))) {
            throw new \InvalidArgumentException($transactionResultArrayErrorMessage, __LINE__);
        }
        if (is_null($transactionResult) || (is_array($transactionResult) && empty($transactionResult))) {
            unset($this->TransactionResult);
        } else {
            $this->TransactionResult = $transactionResult;
        }
        return $this;
    }
    /**
     * Add item to TransactionResult value
     * @throws \InvalidArgumentException
     * @param \StructType\TransactionResult $item
     * @return \ArrayType\ArrayOfTransactionResult
     */
    public function addToTransactionResult(\StructType\TransactionResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TransactionResult) {
            throw new \InvalidArgumentException(sprintf('The TransactionResult property can only contain items of type \StructType\TransactionResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TransactionResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TransactionResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TransactionResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TransactionResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TransactionResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TransactionResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TransactionResult
     */
    public function getAttributeName()
    {
        return 'TransactionResult';
    }
}
